/*

Copyright 2011 Eli Dupree

This file is part of Eli Dupree's currently-unnamed experimental Haskell game, ported to C++.

This game is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this game.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef HASKELLTOCPPGAME_ZGEOM_HPP
#define HASKELLTOCPPGAME_ZGEOM_HPP

#include "ZTree.hpp"
#include "ExactGeom.hpp"

namespace ZGeom {

void insertAndGetOverlapsOfShape(ZTree::ZTree &tree, ObjectIndex idx, ExactGeom::Shape shape, std::set<std::pair<ObjectIndex, ObjectIndex> > &overlapsCollector);
void insertShape(ZTree::ZTree &tree, ObjectIndex idx, ExactGeom::Shape shape);
void getOverlapsOfShape(ZTree::ZTree &tree, ObjectIndex idx, ExactGeom::Shape shape, std::set<std::pair<ObjectIndex, ObjectIndex> > &overlapsCollector);

// mainly a debugging function
std::vector<ExactGeom::Bounds> shapeZBoxBoundses(ExactGeom::Shape shape);

}

#endif

